-- PMDG 737 NGX LUA code for Opencockpits EFIS to be used in FSUIPC
-- File: NGXEFIS_PP_202
-- January 2012
-- Roar Kristensen

--***************************************************************************************
-- **** Captain EFIS ***********
--***************************************************************************************

function WXR_TERR (off, val)
    if logic.And(val, 0x0001) ~= 0 then
    WXR ()
    elseif logic.And(val, 0x0002) ~= 0 then
	STA ()
    elseif logic.And(val, 0x0004) ~= 0 then
    WPT ()
    elseif logic.And(val, 0x0008) ~= 0 then
    ARPT ()
    elseif logic.And(val, 0x0010) ~= 0 then
    DATA ()
    elseif logic.And(val, 0x0020) ~= 0 then
    POS ()
    elseif logic.And(val, 0x0040) ~= 0 then
    TERR ()
    elseif logic.And(val, 0x0080) ~= 0 then
    FPV ()
    elseif logic.And(val, 0x0100) ~= 0 then
    MTRS ()
    elseif logic.And(val, 0x0200) ~= 0 then
    MINS ()
    elseif logic.And(val, 0x0400) ~= 0 then
    BARO ()
    elseif logic.And(val, 0x0800) ~= 0 then
    TFC ()
	elseif logic.And(val, 0x1000) ~= 0 then
    CTR ()
	end
end

function APP_PLN (off, val)
	if logic.And(val, 0x0001) ~= 0 then
    APP_E ()
    elseif logic.And(val, 0x0002) ~= 0 then
    VOR_E ()
    elseif logic.And(val, 0x0004) ~= 0 then
    MAP ()
    elseif logic.And(val, 0x0008) ~= 0 then
    PLN ()
	end
end
	
function MINS_DB (off, val) 
   MINS_MODE_toggle ()
end

function MINS_SB (off, val) 
	MINS_RST_toggle ()
end

function BARO_SB (off, val)
	 BARO_MODE_toggle ()
    
end

function BARO_DB (off, val)
     BARO_in_hpa_toggle ()
end

function MINS (off, val)

if val > 0 then
					MINS_inc ()
					ipc.writeUB("66DA", 0)				 
elseif val < 0 then
					MINS_dec ()
					ipc.writeUB("66DA", 0)
					end			
end

function BARO (off, val)
 
if val > 0 then
					BARO_inc ()
					ipc.writeUB("66DB", 0)					
elseif val < 0 then
					BARO_dec ()
					ipc.writeUB("66DB", 0)
					end			
end

function RNG (off, val)	
    if logic.And(val, 0x0001) ~= 0 then
	RNG_5 ()
    elseif logic.And(val, 0x0002) ~= 0 then
    RNG_10 ()
	elseif logic.And(val, 0x0004) ~= 0 then
    RNG_20 ()
	elseif logic.And(val, 0x0008) ~= 0 then
    RNG_40()
    elseif logic.And(val, 0x0010) ~= 0 then
    RNG_80 ()
	elseif logic.And(val, 0x0020) ~= 0 then
	RNG_160 ()
	elseif logic.And(val, 0x0040) ~= 0 then
	RNG_320 ()
	elseif logic.And(val, 0x0080) ~= 0 then
    RNG_640 ()
    end
end

function VOR1 (off, val)
	if val == 1 then
    ipc.control(69990, -2147483648)
    ipc.control(69990, 524288)
	elseif val == 0 then
	ipc.control(69990, 536870912)
    ipc.control(69990, 131072)
	end
end
	
function ADF1 (off, val)
	if val == 1 then
	ipc.control(69990, 536870912)
    ipc.control(69990, 131072)
	elseif val == 0 then
    ipc.control(69990, -2147483648)
    ipc.control(69990, 524288)
	end
end


function VOR2 (off, val)
	if val == 1 then
    ipc.control(70000, -2147483648)
    ipc.control(70000, 524288)
	elseif val == 0 then
	ipc.control(70000, 536870912)
    ipc.control(70000, 131072)
	end
end
	
function ADF2 (off, val)
	if val == 1 then
	ipc.control(70000, 536870912)
    ipc.control(70000, 131072)
	elseif val == 0 then
    ipc.control(70000, -2147483648)
    ipc.control(70000, 524288)
	end
end

function MINS_MODE_toggle ()
    ipc.control(69988, 536870912)
    ipc.control(69988, 131072)
end

function MINS_RST_toggle ()
    	addr = 69989
	dec ()
end
function BARO_in_hpa_toggle ()
    ipc.control(69998, 536870912)
	ipc.control(69998, 131072)
end

function BARO_MODE_toggle ()
   	addr = 69999
     	dec ()
end
function MINS_inc ()
    ipc.control(69987, 16384)
end

function MINS_dec ()
    ipc.control(69987, 8192)
end

function BARO_inc ()
    ipc.control(69997, 16384)
end

function BARO_dec ()
    ipc.control(69997, 8192)
end

function APP_E ()
	addr=69991
	dec0 ()
end
function VOR_E ()
	addr=69991
    if ipc.readLvar('ngx_switch_359_a') == 0 then
	inc0 ()
    else
	dec0 ()
end
end
function MAP ()
	addr=69991
    if ipc.readLvar('ngx_switch_359_a') == 10 then
	inc0 ()
    else
	dec0 ()
end
end
function PLN ()
	addr=69991
    if ipc.readLvar('ngx_switch_359_a') == 20 then
	inc0 ()
    else
	dec0 ()
end
end
function inc0 ()
    ipc.control(addr, 16384)
end
function dec0 ()
    ipc.control(addr, 8192)
end
function CTR ()
	addr = 69992
     	dec ()
end
function RNG_5 ()
	addr=69993
	dec0 ()
end
function RNG_10 ()
	addr=69993
    if ipc.readLvar('ngx_switch_361_a') == 0 then
	inc0 ()
    else
	dec0 ()
end
end
function RNG_20 ()
	addr=69993
    if ipc.readLvar('ngx_switch_361_a') == 10 then
	inc0 ()
    else
	dec0 ()
end
end
function RNG_40 ()
	addr=69993
    if ipc.readLvar('ngx_switch_361_a') == 20 then
	inc0 ()
    else
	dec0 ()
end
end
function RNG_80 ()
	addr=69993
    if ipc.readLvar('ngx_switch_361_a') == 30 then
	inc0 ()
    else
	dec0 ()
end
end
function RNG_160 ()
	addr=69993
    if ipc.readLvar('ngx_switch_361_a') == 40 then
	inc0 ()
    else
	dec0 ()
end
end
function RNG_320 ()
	addr=69993
    if ipc.readLvar('ngx_switch_361_a') == 50 then
	inc0 ()
    else
	dec0 ()
end
end
function RNG_640 ()
	addr=69993
    if ipc.readLvar('ngx_switch_361_a') == 60 then
	inc0 ()
    else
	dec0 ()
end
end
function TFC ()
    	addr = 69994
     	dec ()
end
function FPV ()
  	addr = 69995
     	dec ()
end
function MTRS ()
    	addr = 69996
     	dec ()
end
function inc0 ()
    ipc.control(addr, 16384)
end
function dec0 ()
    ipc.control(addr, 8192)
end
function inc ()
    ipc.control(addr, -2147483648)
    ipc.control(addr, 524288)
end
function dec ()
    ipc.control(addr, 536870912)
    ipc.control(addr, 131072)
end

function WXR ()
    	addr = 70001
	dec ()
end
function STA ()
    	addr = 70002
	dec ()
end
function WPT ()
  	addr = 70003
	dec ()
end
function ARPT ()
	addr = 70004
	dec ()
end
function DATA ()
    	addr = 70005
	dec ()
end
function POS ()
    	addr = 70006
	dec ()
end
function TERR ()
	addr = 70007
	dec ()
end
--***************************************************************************************
-- ** Routines for look for EFIS buttons and commands **
--***************************************************************************************

event.offset(0x66D0, "UW", "WXR_TERR")
event.offset(0x66D2, "UB", "APP_PLN")
event.offset(0x66D3, "UB", "RNG")
event.intercept(0x66D4, "UB", "MINS_DB")
event.intercept(0x66D5, "UB", "BARO_DB")
event.offset(0x66D6, "UB", "VOR1")
event.offset(0x66D7, "UB", "ADF1")
event.offset(0x66D8, "UB", "VOR2")
event.offset(0x66D9, "UB", "ADF2")
event.offset(0x66DA, "SB", "MINS")
event.offset(0x66DB, "SB", "BARO")
event.intercept(0x66DC, "UB", "MINS_SB")
event.intercept(0x66DD, "UB", "BARO_SB")
