-- PMDG 737 NGX LUA code for Opencockpits MCP to be used in FSUIPC
-- File: NGXMCP_202
-- December 2011
-- Roar Kristensen
--***************************************************************************************
-- ** System initial values set **
--***************************************************************************************
-- ** MCP initial values **
    hdg_mode = 1
    atarm = -1
    crsl = 500
    crsr = 500
    spd = -1
    hdg = -1
    alt = -1
    vsw = -1
    MCP_N1 = -1
    MCP_Speed = -1
    MCP_LvlChg = -1
    MCP_VNav = -1
    MCP_LNav = -1
    MCP_HdgSel = -1
    MCP_AltHold = -1
    MCP_CMDA = -1
    MCP_CMDB = -1
    MCP_CWSA = -1
    MCP_CWSB = -1
    MCP_VORLock = -1
    MCP_App = -1
    MCP_VS = -1
	
	ipc.writeUB("66E8", 0)
	ipc.writeUB("66E9", 0)
	ipc.writeUB("66EA", 0)
	ipc.writeUB("66EB", 0)
	ipc.writeUB("66EC", 0)
	ipc.writeUB("66ED", 0)
	

	if ipc.readUB("66E4") == 1 and ipc.readLvar('ngx_switch_378_a') == 100 then
			ipc.control(70010, 536870912)
			ipc.control(70010, 131072)
				else 
						if ipc.readUB("66E4") == 0 and ipc.readLvar('ngx_switch_378_a') == 0 then
						ipc.control(70010, 536870912)
						ipc.control(70010, 131072)
						end
	end
	
	if ipc.readUB("66E5") == 1 and ipc.readLvar('ngx_switch_380_a') == 100 then
			ipc.control(70012, 536870912)
			ipc.control(70012, 131072)
				else 
						if ipc.readUB("66E5") == 0 and ipc.readLvar('ngx_switch_380_a') == 0 then
						ipc.control(70012, 536870912)
						ipc.control(70012, 131072)
						end
	end
	

	if ipc.readUB("66E6") == 0 and ipc.readLvar('ngx_switch_406_a') == 100 then
			ipc.control(70038, 536870912)
			ipc.control(70038, 131072)
				else 
						if ipc.readUB("66E6") == 1 and ipc.readLvar('ngx_switch_406_a') == 0 then
						ipc.control(70038, 536870912)
						ipc.control(70038, 131072)
						end
	end



	if ipc.readUB("66E7") == 1 and ipc.readLvar('ngx_switch_407_a') == 100 then
			ipc.control(70039, 536870912)
			ipc.control(70039, 131072)
				else 
						if ipc.readUB("66E7") == 0 and ipc.readLvar('ngx_switch_407_a') == 0 then
						ipc.control(70039, 536870912)
						ipc.control(70039, 131072)
						end
	end

		
if crsl ~= ipc.readLvar("L:ngx_CRSwindowL") then
crsl = ipc.readLvar("L:ngx_CRSwindowL")
ipc.writeUW("66C0", crsl)
end

if spd ~= ipc.readLvar("L:ngx_SPDwindow") then
spd = ipc.readLvar("L:ngx_SPDwindow")
ipc.writeUW("66C2", spd)
end

if hdg ~= ipc.readLvar("L:ngx_HDGwindow") then
hdg = ipc.readLvar("L:ngx_HDGwindow")
ipc.writeUW("66C4", hdg)
end

if alt ~= ipc.readLvar("L:ngx_ALTwindow") then
alt = ipc.readLvar("L:ngx_ALTwindow")
ipc.writeUW("66C6", ipc.readLvar("L:ngx_ALTwindow") / 100)
end
--if ipc.readLvar("L:ngx_MCP_VS") == 1 then	
if vsw ~= ipc.readLvar("L:ngx_VSwindow") then
vsw = -20000
ipc.writeSW("66D0", -20000)
end

if crsr ~= ipc.readLvar("L:ngx_CRSwindowR") then
crsr = ipc.readLvar("L:ngx_CRSwindowR")
ipc.writeUW("66CA", crsr)
end
--***************************************************************************************
-- ** Procedures for reading MCP windows and sending to SIOC via FSUIPC offsets****
--***************************************************************************************

function  CRSL_show ()
        crsl = ipc.readLvar("L:ngx_CRSwindowL")
        ipc.writeUW("66C0", crsl)
        end

function SPD_show ()
		
        spd = ipc.readLvar("L:ngx_SPDwindow")
		if spd > 1 then
        ipc.writeUW("66C2", spd)
		else
		spd = spd *100
		ipc.writeUW("66C2", spd)
end
end

function HDG_show ()
        hdg = ipc.readLvar("L:ngx_HDGwindow")
        ipc.writeUW("66C4", hdg)
end

function ALT_show ()	
        alt = ipc.readLvar("L:ngx_ALTwindow")
        ipc.writeUW("66C6", alt / 100)
end

function VS_show ()
        vsw = ipc.readLvar("L:ngx_VSwindow")
        ipc.writeSW("66C8", vsw)
end

function  CRSR_show ()
        crsr = ipc.readLvar("L:ngx_CRSwindowR")
        ipc.writeUW("66CA", crsr)
end
--***************************************************************************************
-- ** Procedures for finding changes in MCP windows and MCP function LEDs****
--***************************************************************************************
    function run_update (time)

    if crsl ~= ipc.readLvar("L:ngx_CRSwindowL") then
    CRSL_show ()
   end	
    if crsr ~= ipc.readLvar("L:ngx_CRSwindowR") then
    CRSR_show ()
    end
	if spd ~= ipc.readLvar("L:ngx_SPDwindow") then
	SPD_show ()
	end  
    if hdg ~= ipc.readLvar("L:ngx_HDGwindow") then
    HDG_show ()
    end
    if alt ~= ipc.readLvar("L:ngx_ALTwindow") then
    ALT_show ()
    end	
	if vsw ~= ipc.readLvar("L:ngx_VSwindow") then
	VS_show ()
	end

    if ipc.readLvar("L:ngx_MCP_ATArm") ~= atarm then
    atarm = ipc.readLvar("L:ngx_MCP_ATArm")
    ipc.writeUB("66F0", atarm)
    end
    if ipc.readLvar("L:ngx_MCP_N1") ~= MCP_N1 then
    MCP_N1 = ipc.readLvar("L:ngx_MCP_N1")
    ipc.writeUB("66F1", MCP_N1)
    end
    if ipc.readLvar("L:ngx_MCP_SPEED") ~= MCP_Speed then
    MCP_Speed = ipc.readLvar("L:ngx_MCP_SPEED")
    ipc.writeUB("66F2", MCP_Speed)
    end
    if ipc.readLvar("L:ngx_MCP_VNav") ~= MCP_VNav then
    MCP_VNav = ipc.readLvar("L:ngx_MCP_VNav")
    ipc.writeUB("66F3", MCP_VNav)
    end
    if ipc.readLvar("L:ngx_MCP_LvlChg") ~= MCP_LvlChg then
    MCP_LvlChg = ipc.readLvar("L:ngx_MCP_LvlChg")
    ipc.writeUB("66F4", MCP_LvlChg)
    end
    if ipc.readLvar("L:ngx_MCP_HdgSel") ~= MCP_HdgSel then
    MCP_HdgSel = ipc.readLvar("L:ngx_MCP_HdgSel")
    ipc.writeUB("66F5", MCP_HdgSel)
    end
    if ipc.readLvar("L:ngx_MCP_LNav") ~= MCP_LNav then
    MCP_LNav = ipc.readLvar("L:ngx_MCP_LNav")
    ipc.writeUB("66F6", MCP_LNav)
    end
    if ipc.readLvar("L:ngx_MCP_VORLock") ~= MCP_VORLock then
    MCP_VORLock = ipc.readLvar("L:ngx_MCP_VORLock")
    ipc.writeUB("66F7", MCP_VORLock)
    end
    if ipc.readLvar("L:ngx_MCP_App") ~= MCP_App then
    MCP_App = ipc.readLvar("L:ngx_MCP_App")
    ipc.writeUB("66F8", MCP_App)
    end
    if ipc.readLvar("L:ngx_MCP_AltHold") ~= MCP_AltHold then
    MCP_AltHold = ipc.readLvar("L:ngx_MCP_AltHold")
    ipc.writeUB("66F9", MCP_AltHold)
    end
    if ipc.readLvar("L:ngx_MCP_VS") ~= MCP_VS then
    MCP_VS = ipc.readLvar("L:ngx_MCP_VS")
    ipc.writeUB("66FA", MCP_VS)
    end
    if MCP_CMDA ~= ipc.readLvar("L:ngx_MCP_CMDA") then
    MCP_CMDA = ipc.readLvar("L:ngx_MCP_CMDA")
    ipc.writeUB("66FB", MCP_CMDA)
    end
    if MCP_CWSA ~= ipc.readLvar("L:ngx_MCP_CWSA") then
    MCP_CWSA = ipc.readLvar("L:ngx_MCP_CWSA")
    ipc.writeUB("66FC", MCP_CWSA)
    end
    if MCP_CMDB ~= ipc.readLvar("L:ngx_MCP_CMDB") then
    MCP_CMDB = ipc.readLvar("L:ngx_MCP_CMDB")
    ipc.writeUB("66FD", MCP_CMDB)
    end
    if MCP_CWSB ~= ipc.readLvar("L:ngx_MCP_CWSB") then
    MCP_CWSB = ipc.readLvar("L:ngx_MCP_CWSB")
    ipc.writeUB("66FE", MCP_CWSB)
    end
end
--***************************************************************************************
-- ** MCP switches *******
--***************************************************************************************
function MCP_FD1(off,val)
	if ipc.readUB("66EF") == 7 then
			if val == 1 and ipc.readLvar('ngx_switch_378_a') == 100 then
			ipc.control(70010, 536870912)
			ipc.control(70010, 131072)
				else 
						if val == 0 and ipc.readLvar('ngx_switch_378_a') == 0 then
						ipc.control(70010, 536870912)
						ipc.control(70010, 131072)
						end
			end
	end
end
	
function MCP_ATARM(off,val)
	if ipc.readUB("66EF") == 7 then
			if val == 1 and ipc.readLvar('ngx_switch_380_a') == 100 then
			ipc.control(70012, 536870912)
			ipc.control(70012, 131072)
				else 
						if val == 0 and ipc.readLvar('ngx_switch_380_a') == 0 then
						ipc.control(70012, 536870912)
						ipc.control(70012, 131072)
						end
			end
	end
 end


function MCP_DISENGAGE(off,val)
if ipc.readUB("66EF") == 7 then
			if val == 0 and ipc.readLvar('ngx_switch_406_a') == 100 then
			ipc.control(70038, 536870912)
			ipc.control(70038, 131072)
				else 
						if val == 1 and ipc.readLvar('ngx_switch_406_a') == 0 then
						ipc.control(70038, 536870912)
						ipc.control(70038, 131072)
						end
			end
	end
end
function MCP_FD2(off,val)
if ipc.readUB("66EF") == 7 then
			if val == 1 and ipc.readLvar('ngx_switch_407_a') == 100 then
			ipc.control(70039, 536870912)
			ipc.control(70039, 131072)
				else 
						if val == 0 and ipc.readLvar('ngx_switch_407_a') == 0 then
						ipc.control(70039, 536870912)
						ipc.control(70039, 131072)
						end
			end
	end
end

function MCP1(off, val)
    if logic.And(val, 0x0010) ~= 0 then
    N1 ()
    elseif logic.And(val, 0x0020) ~= 0 then
	SPEED ()
    elseif logic.And(val, 0x0040) ~= 0 then
    CO ()
    elseif logic.And(val, 0x0080) ~= 0 then
    SPD_INTV ()
    elseif logic.And(val, 0x0100) ~= 0 then
    VNAV ()
    elseif logic.And(val, 0x0200) ~= 0 then
    LVLCHG ()
    elseif logic.And(val, 0x0400) ~= 0 then
    HDGSEL ()
    elseif logic.And(val, 0x0800) ~= 0 then
    HDG_BANK ()
    elseif logic.And(val, 0x1000) ~= 0 then
    LNAV ()
    elseif logic.And(val, 0x2000) ~= 0 then
    VORLOC ()
    elseif logic.And(val, 0x4000) ~= 0 then
    APP ()
    elseif logic.And(val, 0x8000) ~= 0 then
    ALT_INTV ()
    end
end

function MCP2(off, val)
    if logic.And(val, 0x0001) ~= 0 then
    ALTHLD ()
    elseif logic.And(val, 0x0002) ~= 0 then
    VS ()
    elseif logic.And(val, 0x0004) ~= 0 then
    CMDA ()
    elseif logic.And(val, 0x0008) ~= 0 then
    CWSA ()
    elseif logic.And(val, 0x0010) ~= 0 then
    CMDB ()
    elseif logic.And(val, 0x0020) ~= 0 then
    CWSB ()
    end
end

--***************************************************************************************
-- ** MCP Dials ********
--***************************************************************************************

function CRSL_chg (off,val)

if val == 255 then
ipc.sleep(0)
else if val > 0 then
local i
       			for i = 1, val do
					ipc.control(70008, 16384)
					ipc.sleep (5)
					end   		
ipc.writeUB("66E8", 255)
CRSL_show ()
	
else if val < 0 then
val = val* -1
local i
       			for i = 1, val do
					ipc.control(70008, 8192)
					ipc.sleep (5)
					end			
ipc.writeUB("66E8", 255)
CRSL_show ()

else if val == 0 then
ipc.writeUB("66E8", 0)
end
end
end
end
end

	
function SPD_chg (off,val)

if val == 255 then
ipc.sleep(0)
else if val > 0 then
local i
       			for i = 1, val do
					ipc.control(70016, 16384)
					ipc.sleep (5)
					end   		
ipc.writeUB("66E9", 255)
SPD_show ()
	
else if val < 0 then
val = val* -1
local i
       			for i = 1, val do
					ipc.control(70016, 8192)
					ipc.sleep (5)
					end			
ipc.writeUB("66E9", 255)
SPD_show ()

else if val == 0 then
ipc.writeUB("66E9", 0)
end
end
end
end
end
		
		function HDG_chg (off,val)
if hdg_mode == 1 then
if val == 255 then
ipc.sleep(0)
else if val > 0 then
local i
       			for i = 1, val do
					ipc.control(70022, 16384)
					ipc.sleep (5)
					end   		
ipc.writeUB("66EA", 255)
HDG_show ()
	
else if val < 0 then
val = val* -1
local i
       			for i = 1, val do
					ipc.control(70022, 8192)
					ipc.sleep (5)
					end			
ipc.writeUB("66EA", 255)
HDG_show ()

else if val == 0 then
ipc.writeUB("66EA", 0)
end
end
end
end

else 
BANK_chg (off,val)
end
end

	function BANK_chg (off,val)
if val == 255 then
ipc.sleep(0)
else if val > 0 then
local i
       			for i = 1, val do
					ipc.control(70021, -2147483648)
					ipc.control(70021, 524288)
					ipc.sleep (5)
					end   		
ipc.writeUB("66EA", 255)

else if val < 0 then
val = val* -1
local i
       			for i = 1, val do
					ipc.control(70021, 536870912)
					ipc.control(70021, 131072)
					ipc.sleep (5)
					end			
ipc.writeUB("66EA", 255)
else if val == 0 then
ipc.writeUB("66EA", 0)
end
end
end
end
end

function ALT_chg (off,val)

if val == 255 then
ipc.sleep(0)
else if val > 0 then
local i
       			for i = 1, val do
					ipc.control(70032, 16384)
					ipc.sleep (5)
					end   		
ipc.writeUB("66EB", 255)
ALT_show ()
	
else if val < 0 then
val = val* -1
local i
       			for i = 1, val do
					ipc.control(70032, 8192)
					ipc.sleep (5)
					end			
ipc.writeUB("66EB", 255)
ALT_show ()

else if val == 0 then
ipc.writeUB("66EB", 0)
end
end
end
end
end


function VS_chg (off,val)

if val == 255 then
ipc.sleep(0)
else if val > 0 then
local i
       			for i = 1, val do
					ipc.control(70033, 8192)
					ipc.sleep (5)
				
					end   		
ipc.writeUB("66EC", 255)
VS_show ()
	
else if val < 0 then
val = val* -1
local i
       			for i = 1, val do
					ipc.control(70033, 16384)
					ipc.sleep (5)
					end			
ipc.writeUB("66EC", 255)
VS_show ()

else if val == 0 then
ipc.writeUB("66EC", 0)
end
end
end
end
end


function CRSR_chg (off,val)

if val == 255 then
ipc.sleep(0)
else if val > 0 then
local i
       			for i = 1, val do
					ipc.control(70041, 16384)
					ipc.sleep (5)
					end   		
ipc.writeUB("66ED", 255)
CRSR_show ()
	
else if val < 0 then
val = val* -1
local i
       			for i = 1, val do
					ipc.control(70041, 8192)
					ipc.sleep (5)
					end			
ipc.writeUB("66ED", 255)
CRSR_show ()

else if val == 0 then
ipc.writeUB("66ED", 0)
end
end
end
end
end
		
--***************************************************************************************
-- ** MCP buttons **************
--***************************************************************************************
function N1 ()
    ipc.control(70013, 536870912)
    ipc.control(70013, 131072)
end
function SPEED ()
if ipc.readLvar("L:ngx_MCP_VNav") == 1 then -- go to SPD_INTV instead
   ipc.control(70019, 536870912)
    ipc.control(70019, 131072)
else
    ipc.control(70014, 536870912)
    ipc.control(70014, 131072)
end
end
function CO ()
    ipc.control(70015, 536870912)
    ipc.control(70015, 131072)
end
function SPD_INTV ()
    ipc.control(70019, 536870912)
    ipc.control(70019, 131072)
end
function ALT_INTV ()
    ipc.control(70517, 536870912)
    ipc.control(70517, 131072)
end
function HDG_BANK ()
    -- toggling HDG / BANK (1/2)
    -- HDG = 1, BANK = 2
  hdg_mode = 3 - hdg_mode
 end
function VNAV ()
    ipc.control(70018, 536870912)
    ipc.control(70018, 131072)
end
function LVLCHG ()
    ipc.control(70023, 536870912)
    ipc.control(70023, 131072)
end
function HDGSEL ()
    ipc.control(70024, 536870912)
    ipc.control(70024, 131072)
end
function LNAV ()
    ipc.control(70029, 536870912)
    ipc.control(70029, 131072)
end
function VORLOC ()
    ipc.control(70028, 536870912)
    ipc.control(70028, 131072)
end
function APP ()
    ipc.control(70025, 536870912)
    ipc.control(70025, 131072)
end
function ALTHLD ()
if ipc.readLvar("L:ngx_MCP_VNav") == 1 then -- go to ALT_INTV instead
    ipc.control(70517, 536870912)
    ipc.control(70517, 131072)
	else
    ipc.control(70026, 536870912)
    ipc.control(70026, 131072)
end
end
function VS ()
    ipc.control(70027, 536870912)
    ipc.control(70027, 131072)
end
function CMDA ()
    ipc.control(70034, 536870912)
    ipc.control(70034, 131072)
end
function CMDB ()
    ipc.control(70035, 536870912)
    ipc.control(70035, 131072)
end
function CWSA ()
    ipc.control(70036, 536870912)
    ipc.control(70036, 131072)
end
function CWSB ()
    ipc.control(70037, 536870912)
    ipc.control(70037, 131072)
end

--***************************************************************************************
-- ** Routines to detect MCP buttons and dials changes **
--***************************************************************************************
event.offset(0x66E4, "UB", "MCP_FD1")
event.offset(0x66E5, "UB", "MCP_ATARM")
event.offset(0x66E6, "UB", "MCP_DISENGAGE")
event.offset(0x66E7, "UB", "MCP_FD2")
event.offset(0x66E0, "UW", "MCP1")
event.offset(0x66E2, "UW", "MCP2")
event.intercept(0x66E8, "SB", "CRSL_chg")
event.intercept(0x66E9, "SB", "SPD_chg")
event.intercept(0x66EA, "SB", "HDG_chg")
event.intercept(0x66EB, "SB", "ALT_chg")
event.intercept(0x66EC, "SB", "VS_chg")
event.intercept(0x66ED, "SB", "CRSR_chg")

--***************************************************************************************
-- ** Timer for MCP diplays and LED update
--***************************************************************************************
event.timer(100, "run_update")


